︠449f506b-b93a-4723-a98a-36c4beca0e93i︠
%html
<p>We choose an elliptic curve E:</p>

︡416874ba-9480-464a-a653-1dd1f42fe9ed︡{"html": "<p>We choose an elliptic curve E:</p>"}︡
︠30a1b12b-108d-4049-8653-f137e8b5e05b︠
E=EllipticCurve('37a'); E
︡da16957d-011d-4327-9f46-b12db8c8f14c︡{"stdout": "Elliptic Curve defined by y^2 + y = x^3 - x over Rational Field"}︡
︠be044fc7-0122-4d12-9b60-d32a05d5ce4e︠
E.galois_representation().is_surjective(2)
︡ad60e615-d3a5-44c8-911e-21999f3eecb5︡{"stdout": "True"}︡
︠9f07d4d6-25ca-46a2-9463-67ddbade3b40︠
rho=E.galois_representation(); rho
︡3c037e74-37c5-44c0-9e47-ad8070c08d2b︡{"stdout": "Compatible family of Galois representations associated to the Elliptic Curve defined by y^2 + y = x^3 - x over Rational Field"}︡
︠1a5eb170-c9cb-48c9-b4e3-b3c5e3c234d0i︠
%html
<p>We choose a Heegner discriminant for E:</p>

︡9ac68fb4-9d4f-48c6-a577-0a91345809cc︡{"html": "<p>We choose a Heegner discriminant for E:</p>"}︡
︠3e21cd4a-3e6b-464f-8b1c-ba9812944058︠
E.heegner_discriminants(100)
︡14f1eb6a-ee89-4da3-a44f-4acd5931f952︡{"stdout": "[-3, -4, -7, -11, -40, -47, -67, -71, -83, -84, -95]"}︡
︠a6e7feb5-b375-40f8-bf1d-c240992dc5f7i︠
%html
<p>With the choice of a Heegner discriminant, -3, we list possible Kolyvagin primes:</p>

︡5f0971ff-ac8c-4abb-94e9-065dd0b10368︡{"html": "<p>With the choice of a Heegner discriminant, -3, we list possible Kolyvagin primes:</p>"}︡
︠fd8c8e23-1166-444a-8311-244b63bdf3a9︠
for ell in prime_range(1000):
    if GF(ell)(E.conductor())!=0 and E.heegner_point(-3,ell).satisfies_kolyvagin_hypothesis(3):
        ell
︡8c1145e7-af51-4732-b8ef-ce5375316a11︡{"stdout": "17\n29\n41\n47\n71\n83\n101\n107\n113\n131\n137\n167\n173\n179\n197\n233\n239\n257\n269\n281\n311\n359\n401\n431\n449\n461\n521\n557\n563\n569\n653\n659\n683\n701\n719\n743\n773\n857\n863\n929\n947\n983"}︡
︠6f0b14da-e94e-4abb-b435-b2a10a3ff929i︠
%html
<p>We define the field L=Q(E[2]):</p>

︡ddb3ae7d-dbeb-4d9b-9c37-ebc95d962a0e︡{"html": "<p>We define the field L=Q(E[2]):</p>"}︡
︠de21341b-c76b-4809-b67c-53871008d439︠
L.<a>=NumberField(x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1); L
︡cd9dc81c-5eaf-449d-9ffb-5bffce59512c︡{"stdout": "Number Field in a with defining polynomial x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1"}︡
︠d205492c-cdb2-4f82-8f4a-8130c99a715d︠
L.is_galois()
︡1ee05a70-c76c-458d-98c5-fce0bfb90efa︡{"stdout": "True"}︡
︠a4471ca4-3da7-49f4-a1f1-6807031cb933︠
EL=E.change_ring(L); EL
︡08944322-40ee-4de9-bef9-d1fa151d71ca︡{"stdout": "Elliptic Curve defined by y^2 + y = x^3 + (-1)*x over Number Field in a with defining polynomial x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1"}︡
︠75faafac-d84b-4a2e-9a16-6baf0c259bb4︠
L.galois_group().is_isomorphic(SymmetricGroup(3))
︡ab4bed76-067a-44d1-aef4-a56a88d73b41︡{"stdout": "True"}︡
︠ba764757-f927-4900-bbcb-b40ab0912b02i︠
%html
<p>Indeed, the 2-division polynomial of E factors completely over L:</p>

︡e5838991-3545-4a12-8701-2f30ac517fb3︡{"html": "<p>Indeed, the 2-division polynomial of E factors completely over L:</p>"}︡
︠f15d3853-a64f-43dc-b6ec-7952418454d8︠
EL.division_polynomial(2).roots(multiplicities=False)
︡2814a5a6-dc73-429c-b202-fa4a28a56ffe︡{"stdout": "[1/2*a^4 - a^3 - a^2 + 3/2*a, 1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2, -1/2*a^5 + a^4 + 2*a^3 - 3*a^2 - 5/2*a + 3/2]"}︡
︠100458c5-02fb-449f-9ff8-08a2af7f5080i︠
%html
<p>We use Robert Miller's awesome number field Selmer group function!</p>

︡d22a9759-4c3e-43a4-857b-abed4445f0f2︡{"html": "<p>We use Robert Miller's awesome number field Selmer group function!</p>"}︡
︠11c64f60-9405-403e-be30-c0aae80e0d1d︠
List=L.primes_above(2)
︡c1a5d74b-7c74-4526-b1db-e7ecf3cd3930︡︡
︠a0eddf89-4444-4b89-b379-9dec0d4c27b5︠
LSelmerGroup=L.selmer_group(List, 2); LSelmerGroup
︡98a14846-7ab5-4502-bb9d-a880ccae497a︡{"stdout": "[a^3 - 2*a^2 - 2*a + 3, -1, a^3 - 2*a^2 - a + 1, a^5 - 3*a^4 - a^3 + 7*a^2 - 2*a - 1, a, a^3 - 2*a^2 - 2*a + 2, a^4 - 3*a^3 - a^2 + 6*a - 1]"}︡
︠eec84cba-4092-4d47-856b-5c251aa36e57i︠
%html
<p>The key difficulty is implementing the L-Selmer group as a vector space. Robert Miller's function only gives a basis as elements of L--we need the structure of the actual group.</p>

︡39615dd3-deb2-45e0-b3a5-3768fb58f880︡{"html": "<p>The key difficulty is implementing the L-Selmer group as a vector space. Robert Miller's function only gives a basis as elements of L--we need the structure of the actual group.</p>"}︡
︠8e6e0394-d17e-479b-a79d-b11fd827be1e︠
F2=FiniteField(2); F2
︡31ad25fb-8352-44ad-83a5-b9479b760a1b︡{"stdout": "Finite Field of size 2"}︡
︠ab77b4a8-b010-4b4e-9c64-bfd513aed73e︠
V=F2^(len(LSelmerGroup)); V
︡b5fa2045-541d-41f9-be75-05a320c24dcd︡{"stdout": "Vector space of dimension 7 over Finite Field of size 2"}︡
︠9a7f877a-6759-4db8-9c74-77cedf664322i︠
%html
<p>Two functions: this one goes from a vector to a Selmer class.</p>

︡049c2160-61d2-46ca-8de5-35cf16e9c188︡{"html": "<p>Two functions: this one goes from a vector to a Selmer class.</p>"}︡
︠745ac054-2ce6-4f20-973f-212f644da6e1︠
def V_to_Selmer(V, LSelmerGroup, v):
    a=1
    for i in range(dim(V)):
        a=a*(LSelmerGroup[i]^v[i])
    return a
︡b2a95609-8336-4b02-ab48-c57450f7c5c4︡︡
︠cec3d4ba-782b-4884-a841-ff4551465b6di︠
%html
<p>This one goes the opposite way. It is by far the most time-consuming operation here.</p>

︡02dd32e8-ace7-41bd-a7b8-139f51c744b9︡{"html": "<p>This one goes the opposite way. It is by far the most time-consuming operation here.</p>"}︡
︠2ae42485-325f-4c2d-aa8b-c7aa3fe34739︠
def Selmer_to_V(V, LSelmerGroup, a):
    for v in V:
        if (a/V_to_Selmer(V, LSelmerGroup, v)).is_square()==True:
            return v
︡ad4af496-c67a-4cc3-a93f-3b269b77562e︡︡
︠1dd82439-5c79-4c88-80d1-33eadbf9d102i︠
%html
<p>Here we learn the Galois action on 2-torsion points.</p>

︡2a13bdd5-c136-4fff-892e-8803adc4ef54︡{"html": "<p>Here we learn the Galois action on 2-torsion points.</p>"}︡
︠8dc6271a-05db-444e-a6d4-c36a65baa993︠
G=L.galois_group(); G
︡66cf348e-b2b5-4d47-9879-4eb4260569b8︡{"stdout": "Galois group of Number Field in a with defining polynomial x^6 - 3*x^5 - 2*x^4 + 9*x^3 - 5*x + 1"}︡
︠cbfdf099-958d-43b9-8d9c-ed5b0f467245︠
P=EL.division_polynomial(2).roots(multiplicities=False)[0]
︡1607a2a7-eb13-473b-876d-62b6dc1dc24e︡︡
︠9944d6c2-c2be-4143-b134-d503a46e6769︠
Q=EL.division_polynomial(2).roots(multiplicities=False)[2]
︡03a5cb3f-25fb-4c58-8e00-92300e81d3ea︡︡
︠f784dc66-1bc2-483a-b994-cc06fb992ba7︠
PQ=EL.division_polynomial(2).roots(multiplicities=False)[1]
︡f0670713-f6ad-408c-aa5e-ae6c6aceb114︡︡
︠017cf63c-140f-4460-923f-62d731029e14︠
tau=G.gens()[0]; sigma=G.gens()[1]^-1
︡db521b2a-8745-4e50-9fde-626a532cfe00︡︡
︠ae63f3e5-1495-44e3-b003-c64018a8b388︠
tau(P)==Q; tau(Q)==P; tau(PQ)==PQ; sigma(P)==Q; sigma(Q)==PQ; sigma(PQ)==P
︡7cbcd8ff-fa35-4605-bd59-7b3e5716c9c5︡{"stdout": "True\nTrue\nTrue\nTrue\nTrue\nTrue"}︡
︠18cdea97-7ac5-426b-9ce7-fb8e4a023f4di︠
%html
<p>W represents the tensor product vector space.</p>

︡6ee09280-4316-4b96-90a4-e2aa361f7245︡{"html": "<p>W represents the tensor product vector space.</p>"}︡
︠2c3d6c58-1ede-4740-ac81-573dd0d80400︠
W=F2^(2*len(LSelmerGroup)); W
︡1e7af4d3-71e7-4cdb-bc23-e943e0543edc︡{"stdout": "Vector space of dimension 14 over Finite Field of size 2"}︡
︠3624d131-b69e-4370-b805-98fd8b3c87dbi︠
%html
<p>Functions for dealing with the tensor product:</p>

︡ce3b0bb7-091e-4253-a2e3-6f4944a77472︡{"html": "<p>Functions for dealing with the tensor product:</p>"}︡
︠8d70df12-fa28-42ed-8854-744713554ebc︠
def Glue(u, v, V, W):
    w=W.zero_vector()
    for i in range(dim(V)):
        w[i]=u[i]
        w[i+dim(V)]=v[i]
    return w
︡ec6a8f91-1be8-4e6c-bc53-94803482c17e︡︡
︠aeb5e725-cf76-4231-bf53-7aa02ee003d8︠
def Split(w, V, W):
    u=V.zero_vector(); v=V.zero_vector()
    for i in range(dim(V)):
        u[i]=w[i]
        v[i]=w[i+dim(V)]
    return [u, v]
︡67045a1a-5c96-42ae-9e4d-37eb681bb17e︡︡
︠b23d628e-71fc-4c43-b929-073784c0bc86i︠
%html
<p>Now we can write the Galois generators as matrices. They are big, but Sage handles them beautifully.</p>

︡76b33c66-ecdf-4860-99e3-00db5f6a7bb7︡{"html": "<p>Now we can write the Galois generators as matrices. They are big, but Sage handles them beautifully.</p>"}︡
︠54248f83-7ca1-4492-99ef-06fedb9faafa︠
ListTau=list(W.basis())
for j in range(dim(V)):
    ListTau[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListTau[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V.zero_vector(), V, W)
MatrixTau=Matrix(ListTau); print MatrixTau.str()
︡67cf1100-8057-4412-bc89-29314d1a79c4︡{"stdout": "[0 0 0 0 0 0 0 1 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 1 0 0 1 0 0]\n[0 0 0 0 0 0 0 0 1 1 1 0 1 0]\n[0 0 0 0 0 0 0 0 1 1 0 0 0 0]\n[0 0 0 0 0 0 0 0 1 1 0 1 1 0]\n[0 0 0 0 0 0 0 0 0 1 0 1 0 1]\n[1 1 1 0 0 1 0 0 0 0 0 0 0 0]\n[0 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 0 0 1 0 0 0 0 0 0 0 0 0]\n[0 1 1 1 0 1 0 0 0 0 0 0 0 0]\n[0 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 1 0 1 1 0 0 0 0 0 0 0 0]\n[0 0 1 0 1 0 1 0 0 0 0 0 0 0]"}︡
︠12f40637-4146-4552-b892-8ee5dc9a597c︠
ListSigma=list(W.basis())
for j in range(dim(V)):
    ListSigma[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListSigma[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
MatrixSigma=Matrix(ListSigma); print MatrixSigma.str()
︡9886a721-4eb0-41a4-81da-592cf2b43907︡{"stdout": "[0 0 0 0 0 0 0 1 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 0 0 0 0 1 1 0 1 1 1]\n[1 1 1 1 1 0 0 1 1 1 1 1 0 0]\n[0 1 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 1 0 1 0 0 0 0 1 0 1 0 0 0]\n[0 1 1 1 0 0 0 0 1 1 1 0 0 0]\n[0 1 1 1 1 1 0 0 1 1 1 1 1 0]\n[0 1 1 0 1 0 0 0 1 1 0 1 0 0]\n[0 1 1 0 1 1 1 0 1 1 0 1 1 1]"}︡
︠c648ae40-e98a-47c7-ac1a-251eac48edb5i︠
%html
<p>Our problem is reduced to finding the common Eigenspace of these two matrices.</p>

︡665d61a8-7ef5-44d3-b4e9-2e7e1c005fa6︡{"html": "<p>Our problem is reduced to finding the common Eigenspace of these two matrices.</p>"}︡
︠3404316d-f203-469a-a698-2492aadbe835︠
Id=Matrix(W.basis())
Eigens=(MatrixSigma-Id).left_kernel().intersection((MatrixTau-Id).left_kernel()); Eigens
︡601f4c0e-bcfb-449f-b429-1a78728dee73︡{"stdout": "Vector space of degree 14 and dimension 2 over Finite Field of size 2\nBasis matrix:\n[0 0 0 1 1 0 0 0 0 0 1 0 1 0]\n[0 0 0 0 0 1 0 0 1 1 0 1 1 0]"}︡
︠60cbb2c2-4eb8-4508-b3a9-ca2c59adcb49︠
for w in Eigens:
    [V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[0]), V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[1])]
︡1fc3f6d9-b104-47ce-8c7b-7cde36d116ba︡{"stdout": "[1, 1]\n[a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1]\n[a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1]\n[-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a]"}︡
︠49b1baa4-c562-4a40-a90b-57eef03dd917i︠
%html
<p>We have bounded the Selmer group inside a group of size 4. Now finding it exactly is a matter of checking a modified local condition at primes above 2. However, we cheat our way out of this process using a different property of the standard Selmer group:</p>

︡a59a598f-db3c-4efb-8103-dccc3a97a151︡{"html": "<p>We have bounded the Selmer group inside a group of size 4. Now finding it exactly is a matter of checking a modified local condition at primes above 2. However, we cheat our way out of this process using a different property of the standard Selmer group:</p>"}︡
︠a658d07c-a423-4bbd-ad6f-62293c42655e︠
RR.<tt>=L[]
M.<b>=L.extension(tt^2-(a^4 - 2*a^3 - 2*a^2 + 4*a - 1))
SS.<uu>=M[]
N.<c>=M.extension(uu^2-(a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1))
EN=EL.change_ring(N)
MWPoint=EN(0,0,1); MWPoint
MWPoint.division_points(2)
︡bfdc365a-47cb-4656-a65b-1b0e9e3c4996︡{"stdout": "[(((-1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*b - 1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*c + (-1/2*a^5 + 3/2*a^4 + a^3 - 4*a^2 - a + 3/2)*b : ((1/2*a^5 - a^4 - 2*a^3 + 2*a^2 + 7/2*a + 1)*b + 1/2*a)*c + (a^5 - 5/2*a^4 - 3*a^3 + 7*a^2 + 3*a - 5/2)*b + 1/2 : 1), (((1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*b + 1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*c + (-1/2*a^5 + 3/2*a^4 + a^3 - 4*a^2 - a + 3/2)*b : ((-1/2*a^5 + a^4 + 2*a^3 - 2*a^2 - 7/2*a - 1)*b - 1/2*a)*c + (a^5 - 5/2*a^4 - 3*a^3 + 7*a^2 + 3*a - 5/2)*b + 1/2 : 1), (((1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*b - 1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*c + (1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2)*b : ((-1/2*a^5 + a^4 + 2*a^3 - 2*a^2 - 7/2*a - 1)*b + 1/2*a)*c + (-a^5 + 5/2*a^4 + 3*a^3 - 7*a^2 - 3*a + 5/2)*b + 1/2 : 1), (((-1/2*a^5 + a^4 + 2*a^3 - 5/2*a^2 - 3*a)*b + 1/2*a^5 - a^4 - 2*a^3 + 5/2*a^2 + 3*a)*c + (1/2*a^5 - 3/2*a^4 - a^3 + 4*a^2 + a - 3/2)*b : ((1/2*a^5 - a^4 - 2*a^3 + 2*a^2 + 7/2*a + 1)*b - 1/2*a)*c + (-a^5 + 5/2*a^4 + 3*a^3 - 7*a^2 - 3*a + 5/2)*b + 1/2 : 1)]"}︡
︠8c7fbf84-6fd3-439a-b2aa-42040c3322afi︠
%html
<p>The first nonzero element in the list above is the true Selmer generator. The others fail (in calculations not shown here). Hence the 2-Selmer group has rank 1, and so does E!</p>

<p>Now let's try a modified Selmer group, using the Kolyvagin prime 17.</p>

︡7cd3db24-ee43-4356-81ab-d0590b3b2626︡{"html": "<p>The first nonzero element in the list above is the true Selmer generator. The others fail (in calculations not shown here). Hence the 2-Selmer group has rank 1, and so does E!</p>\n\n<p>Now let's try a modified Selmer group, using the Kolyvagin prime 17.</p>"}︡
︠a4210284-e1b4-478b-ab88-4df3a051973a︠
List=list(set(L.primes_above(2)).union(set(L.primes_above(17)))); List
︡a1050e1b-527b-4041-b290-af9fd67d8fdd︡{"stdout": "[Fractional ideal (a^5 - 2*a^4 - 4*a^3 + 4*a^2 + 6*a), Fractional ideal (a^3 - 2*a^2 - 2*a + 3), Fractional ideal (2*a^3 - 2*a^2 - 5*a), Fractional ideal (-a^5 + 3*a^4 + 2*a^3 - 10*a^2 + a + 5)]"}︡
︠051921ab-0dcc-4ea8-a5af-189f51af4101︠
LSelmerGroup=L.selmer_group(List, 2); LSelmerGroup
︡d4e83907-3055-4a52-aaed-346008bee596︡{"stdout": "[a^5 - 2*a^4 - 4*a^3 + 4*a^2 + 6*a, a^3 - 2*a^2 - 2*a + 3, 2*a^3 - 2*a^2 - 5*a, -a^5 + 3*a^4 + 2*a^3 - 10*a^2 + a + 5, -1, a^3 - 2*a^2 - a + 1, a^5 - 3*a^4 - a^3 + 7*a^2 - 2*a - 1, a, a^3 - 2*a^2 - 2*a + 2, a^4 - 3*a^3 - a^2 + 6*a - 1]"}︡
︠2c802c15-743c-4ed2-b4de-fdc8b1a59527︠
V=F2^(len(LSelmerGroup)); V
︡cfd18225-d1c0-4506-ad29-ced8de16555b︡{"stdout": "Vector space of dimension 10 over Finite Field of size 2"}︡
︠1db020c2-9d44-4716-a533-889cd7632dfe︠
W=F2^(2*len(LSelmerGroup)); W
︡98cea236-ace2-497f-a367-91838c201794︡{"stdout": "Vector space of dimension 20 over Finite Field of size 2"}︡
︠6167f991-7e2f-4d1c-85b2-aea2411ced7a︠
ListTau=list(W.basis())
for j in range(dim(V)):
    ListTau[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListTau[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, tau(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V.zero_vector(), V, W)
MatrixTau=Matrix(ListTau); print MatrixTau.str()
︡b74b8125-86ff-44bc-946a-5a1a575f1fb3︡{"stdout": "[0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 1]\n[1 0 0 0 1 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 1 0 0 1 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 1 0 0 1 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 1 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 1 0 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 1 1 0 1 1 0 0 0 0 0 0 0 0 0 0 0]\n[0 0 0 0 0 1 0 1 0 1 0 0 0 0 0 0 0 0 0 0]"}︡
︠8bc5b950-519a-4def-a395-074821dffb8b︠
ListSigma=list(W.basis())
for j in range(dim(V)):
    ListSigma[j]=Glue(V.zero_vector(), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
    ListSigma[j+dim(V)]=Glue(Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), Selmer_to_V(V, LSelmerGroup, sigma(V_to_Selmer(V, LSelmerGroup, V.basis()[j]))), V, W)
MatrixSigma=Matrix(ListSigma); print MatrixSigma.str()
︡2f41855e-af94-44fc-99f9-759d6465d9c2︡{"stdout": "[0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 1 1 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 1 0 0 0 1 1 0 0 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 1 0 1 1 1]\n[0 0 1 0 1 1 1 1 0 0 0 0 1 0 1 1 1 1 0 0]\n[0 1 0 0 1 1 1 1 0 0 0 1 0 0 1 1 1 1 0 0]\n[0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0 0]\n[1 0 0 0 1 1 0 0 1 0 1 0 0 0 1 1 0 0 1 0]\n[0 0 0 0 1 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0]\n[0 0 0 0 1 0 1 0 0 0 0 0 0 0 1 0 1 0 0 0]\n[0 0 0 0 1 1 1 0 0 0 0 0 0 0 1 1 1 0 0 0]\n[0 0 0 0 1 1 1 1 1 0 0 0 0 0 1 1 1 1 1 0]\n[0 0 0 0 1 1 0 1 0 0 0 0 0 0 1 1 0 1 0 0]\n[0 0 0 0 1 1 0 1 1 1 0 0 0 0 1 1 0 1 1 1]"}︡
︠d02ee471-0231-4995-b0eb-c4553b3d9278︠
Id=Matrix(W.basis())
Eigens=(MatrixSigma-Id).left_kernel().intersection((MatrixTau-Id).left_kernel()); Eigens
︡e2f8a514-b5d9-429e-a3a0-4ecc6a0df997︡{"stdout": "Vector space of degree 20 and dimension 3 over Finite Field of size 2\nBasis matrix:\n[1 0 1 0 0 0 0 0 0 0 1 0 0 1 1 1 1 1 0 0]\n[0 0 0 0 0 0 1 1 0 0 0 0 0 0 0 0 1 0 1 0]\n[0 0 0 0 0 0 0 0 1 0 0 0 0 0 1 1 0 1 1 0]"}︡
︠055ff151-4054-4757-a08e-cb1c1401247c︠
for w in Eigens:
    [V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[0]), V_to_Selmer(V, LSelmerGroup, Split(w, V, W)[1])]
︡f311127b-854a-4ec4-a671-d0e8cf2a5bd1︡{"stdout": "[1, 1]\n[-7*a^5 + 14*a^4 + 23*a^3 - 32*a^2 - 25*a + 5, -5*a^4 + 10*a^3 - a^2 - 4*a + 2]\n[a^4 - 2*a^3 - 2*a^2 + 4*a - 1, a^5 - 4*a^4 + a^3 + 9*a^2 - 5*a - 1]\n[-2*a^5 + 12*a^3 - 5*a^2 - 16*a + 4, -5*a^5 + 30*a^4 - 41*a^3 - 17*a^2 + 35*a - 8]\n[a^3 - 2*a^2 - 2*a + 2, 2*a^4 - 5*a^3 - a^2 + 4*a - 1]\n[5*a^5 - 10*a^4 - 14*a^3 + 18*a^2 + 13*a - 6, 5*a^5 - 19*a^4 + 2*a^3 + 43*a^2 - 16*a - 10]\n[-a^5 + 3*a^4 - 5*a^2 + 4*a - 1, -a^2 + a]\n[-a^5 + 6*a^3 + 6*a^2 - 8*a + 2, 2*a^4 - 4*a^3 - 3*a^2 + 5*a + 6]"}︡
︠4e041b2d-12b5-4a8f-8121-6dbf2fc8cebai︠
%html
<p>To narrow down this group of size 8, we must check the transverse condition at primes above 17. The function below will do this:</p>

︡2d553d16-8ddf-4cab-9165-8d8a1e6c3381︡{"html": "<p>To narrow down this group of size 8, we must check the transverse condition at primes above 17. The function below will do this:</p>"}︡
︠ea81b622-1629-4ab6-bbc0-c2bcdf4057c0︠
def local_conditions(A, p, u, a):
    F=A.residue_field(p)
    vp=a.valuation(p)
    b=F(a/u^vp)
    unramified=(vp%2==0)
    transverse=(b.nth_root(2, all=True)!=[])
    return [unramified, transverse]
︡7eabb89d-8064-417b-abfd-39920f812660︡︡
